#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>


FILE *datei,*ziel;
int size,lsize;
char *buffer;
char *symbol;
int i;

BOOL getLine(FILE **handle)
{//liest eine ganze Zeile (bis '\n') aus der datei
  BYTE *zeichen;

  //lesepuffer fr ein zeichen anlegen und initialisieren
  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';

  //zeilenpuffer neu initialisieren
  *buffer = '\0';
  lsize = 0;

  //zeile (zeichenweise) aus der datei lesen... (abbrechen bei dateiende)
  if((fread(zeichen,sizeof(BYTE),1,*handle)) == 0)
    return(false);

  while(*zeichen != '\n')
  {
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    fread(zeichen,sizeof(BYTE),1,*handle);
  }

  //das letzte zeichen noch anfgen
  lsize++;
  buffer = (char *)realloc(buffer,lsize+1);
  strncat(buffer,(char *)zeichen,1);

  //leerzeilen und zeilen mit '(xxx)' (zyklen) weglesen
  while((strncmp(buffer,"\n",1) == 0) || (strncmp(buffer,"(",1) == 0))
  {
    *zeichen = '\0';
    *buffer = '\0';
    lsize = 0;
  
    //zeile aus der datei lesen... (abbrechen bei dateiende)
    if((fread(zeichen,sizeof(BYTE),1,*handle)) == 0)
      return(false);

    while(*zeichen != '\n')
    {
      lsize++;
      buffer = (char *)realloc(buffer,lsize+1);
      strncat(buffer,(char *)zeichen,1);
    
      //nchstes zeichen lesen
      fread(zeichen,sizeof(BYTE),1,*handle);
    }

    //das letzte zeichen noch anfgen
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
  }

  i = 0;
  free(zeichen);
  return(true);
}


BOOL scanLine()
{//liefert alles zwischen doppeltabs bzw. zeilenende (symbol)
  BYTE *zeichen;

  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';
  
  //puffer neu initialisieren
  *symbol = '\0';
  size = 0;

  //erstes zeichen einlesen
  *zeichen = (BYTE)(*(buffer+i));

  //evtl. anzahl der aufrufe '(xxxx)' weglesen
  if(*zeichen == '(')
  {
    i += 7;
    *zeichen = (BYTE)(*(buffer+i));
  }

  //abbruchbedingungen fr das einlesen
  while((*zeichen != '\t') && (i < lsize))
  {
    //zeichen im puffer zusammensetzen
    size++;
    symbol = (char *)realloc(symbol,size+1);
    strncat(symbol,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    i++;
    *zeichen = (BYTE)(*(buffer+i));
  }

  //zweites tab bergehen
  i += 2;

  free(zeichen);
  return(true);
}


int main(int argc, char* argv[])
{
  char *statement;
  char *quelle;
  char *methode;
  int qsize=1,msize=1;
  int position;
  BOOL status;

	if(argc != 3)
  {
    printf("essenz <quelldatei> <zieldatei>");
    return(0);
  }

	printf("ESSENZ...");

  //quelldatei zum lesen ffnen
	if((datei=fopen(argv[1],"r")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[1]);
		return(-1);
	}

  //zieldatei zum schreiben ffnen
	if((ziel=fopen(argv[2],"w+")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[2]);
		return(-1);
	}

  //zeilenpuffer einrichten
  buffer = (char *)malloc(1);
  *buffer = '\0';

  //symbolpuffer einrichten
  symbol = (char *)malloc(1);
  *symbol = '\0';
 
  while(getLine(&datei))
  {
    //zeit einlesen
    scanLine();

    //dateinamen einlesen und sichern
    scanLine();
    qsize = size;
    quelle = (char *)malloc(qsize+1);
    strncpy(quelle,symbol,qsize+1);

    //methodennamen einlesen und sichern
    scanLine();
    msize = size;
    methode = (char *)malloc(msize+1);
    strncpy(methode,symbol,msize+1);

    //initialisierung: methode noch nicht enthalten
    status = false;
    
    //dateizeiger sichern
    position = ftell(ziel);

    //dateizeiger an anfang der datei setzen
    fseek(ziel,0,SEEK_SET);

    //methodenname in der zieldatei suchen
    while(getLine(&ziel))
    {

	  //zeit weglesen
	  scanLine();

	  //dateinamen einlesen
      scanLine();

      //dateinamen vergleichen
      if(strcmp(symbol,quelle) != 0)
        continue;

      //methodennamen einlesen
      scanLine();

      //methodennamen vergleichen
      if(strcmp(symbol,methode) == 0)
      {
        status = true;
        break;
      }
    }

    //dateizeiger zurcksetzen
    fseek(ziel,position,SEEK_SET);

    //methode noch nicht enthalten => in datei schreiben
    if(!status)
    {
      statement = (char *)malloc(qsize+msize+5);
      *statement = '\0';
	  strncat(statement,"\t\t",2);
      strncat(statement,quelle,qsize+1);
      strncat(statement,"\t\t",2);
      strncat(statement,methode,msize+1);
      fwrite(statement,qsize+msize+4,1,ziel);
      free(statement);
    }
    
    free(quelle);
    free(methode);
  }

  free(buffer);
  free(symbol);
  fclose(datei);
  fclose(ziel);
  
  printf("fertig\n");
  return (0);
}
